<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVersionAreaMapDesign ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfVersionAreaMapDesign
 * @subpackage Arrays
 */
class ArrayOfVersionAreaMapDesign extends AbstractStructArrayBase
{
    /**
     * The VersionAreaMapDesign
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\VersionAreaMapDesign[]
     */
    public $VersionAreaMapDesign;
    /**
     * Constructor method for ArrayOfVersionAreaMapDesign
     * @uses ArrayOfVersionAreaMapDesign::setVersionAreaMapDesign()
     * @param \patest\StructType\VersionAreaMapDesign[] $versionAreaMapDesign
     */
    public function __construct(array $versionAreaMapDesign = array())
    {
        $this
            ->setVersionAreaMapDesign($versionAreaMapDesign);
    }
    /**
     * Get VersionAreaMapDesign value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\VersionAreaMapDesign[]|null
     */
    public function getVersionAreaMapDesign()
    {
        return isset($this->VersionAreaMapDesign) ? $this->VersionAreaMapDesign : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVersionAreaMapDesign method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVersionAreaMapDesign method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVersionAreaMapDesignForArrayConstraintsFromSetVersionAreaMapDesign(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVersionAreaMapDesignVersionAreaMapDesignItem) {
            // validation for constraint: itemType
            if (!$arrayOfVersionAreaMapDesignVersionAreaMapDesignItem instanceof \patest\StructType\VersionAreaMapDesign) {
                $invalidValues[] = is_object($arrayOfVersionAreaMapDesignVersionAreaMapDesignItem) ? get_class($arrayOfVersionAreaMapDesignVersionAreaMapDesignItem) : sprintf('%s(%s)', gettype($arrayOfVersionAreaMapDesignVersionAreaMapDesignItem), var_export($arrayOfVersionAreaMapDesignVersionAreaMapDesignItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VersionAreaMapDesign property can only contain items of type \patest\StructType\VersionAreaMapDesign, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VersionAreaMapDesign value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\VersionAreaMapDesign[] $versionAreaMapDesign
     * @return \patest\ArrayType\ArrayOfVersionAreaMapDesign
     */
    public function setVersionAreaMapDesign(array $versionAreaMapDesign = array())
    {
        // validation for constraint: array
        if ('' !== ($versionAreaMapDesignArrayErrorMessage = self::validateVersionAreaMapDesignForArrayConstraintsFromSetVersionAreaMapDesign($versionAreaMapDesign))) {
            throw new \InvalidArgumentException($versionAreaMapDesignArrayErrorMessage, __LINE__);
        }
        if (is_null($versionAreaMapDesign) || (is_array($versionAreaMapDesign) && empty($versionAreaMapDesign))) {
            unset($this->VersionAreaMapDesign);
        } else {
            $this->VersionAreaMapDesign = $versionAreaMapDesign;
        }
        return $this;
    }
    /**
     * Add item to VersionAreaMapDesign value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\VersionAreaMapDesign $item
     * @return \patest\ArrayType\ArrayOfVersionAreaMapDesign
     */
    public function addToVersionAreaMapDesign(\patest\StructType\VersionAreaMapDesign $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\VersionAreaMapDesign) {
            throw new \InvalidArgumentException(sprintf('The VersionAreaMapDesign property can only contain items of type \patest\StructType\VersionAreaMapDesign, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VersionAreaMapDesign[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\VersionAreaMapDesign|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\VersionAreaMapDesign|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\VersionAreaMapDesign|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\VersionAreaMapDesign|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\VersionAreaMapDesign|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VersionAreaMapDesign
     */
    public function getAttributeName()
    {
        return 'VersionAreaMapDesign';
    }
}
